/*
 * Java
 *
 * Copyright 2016-2019 MicroEJ Corp. All rights reserved.
 * MicroEJ Corp. PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.giml.annotation.processor;

import javax.lang.model.type.ArrayType;
import javax.lang.model.type.DeclaredType;
import javax.lang.model.type.ErrorType;
import javax.lang.model.type.ExecutableType;
import javax.lang.model.type.IntersectionType;
import javax.lang.model.type.NoType;
import javax.lang.model.type.NullType;
import javax.lang.model.type.PrimitiveType;
import javax.lang.model.type.TypeMirror;
import javax.lang.model.type.TypeVariable;
import javax.lang.model.type.TypeVisitor;
import javax.lang.model.type.UnionType;
import javax.lang.model.type.WildcardType;

/**
 *
 */
public class GIMLTypeVisitor implements TypeVisitor<String, Void> {

	@Override
	public String visit(TypeMirror t, Void p) {
		return null;
	}

	@Override
	public String visit(TypeMirror t) {
		return null;
	}

	@Override
	public String visitPrimitive(PrimitiveType t, Void p) {
		return t.toString();
	}

	@Override
	public String visitNull(NullType t, Void p) {
		return "null";
	}

	@Override
	public String visitArray(ArrayType t, Void p) {
		return this.visit(t.getComponentType()).concat("[]");
	}

	@Override
	public String visitDeclared(DeclaredType t, Void p) {
		return t.toString();
	}

	@Override
	public String visitError(ErrorType t, Void p) {
		throw new RuntimeException(
				String.format("Unable to model class or interface '%s': maybe class or interface in not classpath",
						t.getEnclosingType().toString()));
	}

	@Override
	public String visitTypeVariable(TypeVariable t, Void p) {
		return null;
	}

	@Override
	public String visitWildcard(WildcardType t, Void p) {
		return null;
	}

	@Override
	public String visitExecutable(ExecutableType t, Void p) {
		return null;
	}

	@Override
	public String visitNoType(NoType t, Void p) {
		return null;
	}

	@Override
	public String visitUnknown(TypeMirror t, Void p) {
		return null;
	}

	@Override
	public String visitUnion(UnionType t, Void p) {
		return null;
	}

	@Override
	public String visitIntersection(IntersectionType arg0, Void arg1) {
		return null;
	}

}
