/*
 * Java
 *
 * Copyright 2019 MicroEJ Corp. All rights reserved.
 * MicroEJ Corp. PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.giml.generator.js;

import com.is2t.giml.jsgenerator.JavaScriptSourceToMicroEJSourceGenerator;
import com.is2t.giml.jsgenerator.global.GlobalObject;
import com.is2t.java.nodes.Expression;
import com.is2t.java.nodes.LocalDeclaration;
import com.is2t.java.nodes.Statement;
import com.is2t.java.nodes.TypeReference;
import com.is2t.java.nodes.expressions.Assignment;
import com.is2t.java.nodes.expressions.IntegerLiteral;
import com.is2t.java.nodes.expressions.LocalAccess;
import com.is2t.java.nodes.expressions.ObjectAllocation;

import jdk.nashorn.internal.ir.CallNode;

/**
 * Global object that allow to access to all user declared identifiers
 */
public class GlobalObjectGIMLIdentifier implements GlobalObject {

	private final String name;
	private final int id;

	public GlobalObjectGIMLIdentifier(String name, int id) {
		this.name = name;
		this.id = id;

	}

	@Override
	public String getGlobalName() {
		return name;
	}

	@Override
	public Statement generateInitialization(JavaScriptSourceToMicroEJSourceGenerator gen) {
		return new Assignment(
				new LocalAccess(new LocalDeclaration(TypeReference.getVoidReference(), gen.javaName(name), null)),
				new ObjectAllocation(new TypeReference(gen.javaFullyQualifiedName("Integer"), 0),
						new Expression[] { new IntegerLiteral(id) }));
	}

	@Override
	public Expression generateCallExpression(JavaScriptSourceToMicroEJSourceGenerator gen, CallNode call,
			String functionName) {
		return null;
	}

}