/*
 * Java
 *
 * Copyright 2016-2017 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.giml.generator.test;

import java.io.DataOutputStream;
import java.io.IOException;

import org.junit.Ignore;

import com.is2t.giml.binary.GIMLWriter;

@Ignore
public class MyGIMLWriter implements GIMLWriter {

	private final DataOutputStream out;

	public MyGIMLWriter(DataOutputStream out) {
		this.out = out;
	}

	@Override
	public void writeVarSInt(int value) {
		System.out.println("MyGIMLWriter.writeVarSInt() value=" + value);
		try {
			this.out.writeInt(value);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void writeVarUInt(int value) {
		System.out.println("MyGIMLWriter.writeVarUInt() value=" + value);
		try {
			this.out.writeInt(value);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void writeVarLong(long value) {
		System.out.println("MyGIMLWriter.writeVarLong() value=" + value);
		try {
			this.out.writeLong(value);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void writeBoolean(boolean value) {
		System.out.println("MyGIMLWriter.writeBoolean() value=" + value);
		try {
			this.out.writeBoolean(value);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void writeFloat(float value) {
		System.out.println("MyGIMLWriter.writeFloat() value=" + value);
		try {
			this.out.writeFloat(value);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void writeDouble(double value) {
		System.out.println("MyGIMLWriter.writeDouble() value=" + value);
		try {
			this.out.writeDouble(value);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void writeNonNLSString(String s) {
		System.out.println("MyGIMLWriter.writeNonNLSString() value=" + s);
		try {
			this.out.writeUTF(s);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void writeNLSStringId(int nlsId) {
		System.out.println("MyGIMLWriter.writeNLSStringId() nlsId= " + nlsId);
		try {
			this.out.writeInt(nlsId);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void markPosition(int identifier) {
		System.out.println("MyGIMLWriter.markPosition() identifier=" + identifier);
		try {
			this.out.writeInt(identifier);
		} catch (IOException e) {
			throw new RuntimeException();
		}

	}

	@Override
	public void complete(long binaryId) throws IOException {
		System.out.println("MyGIMLWriter.complete()");
		this.out.writeLong(binaryId);
		this.out.flush();
		this.out.close();

	}

}
