/*
 * Java
 *
 * Copyright 2016 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.giml.xml.parser.exception;

/**
 * An instance of {@code XMLParserMalformedTemplateException} is thrown to indicate that a template declaration is
 * malformed in an XML document.
 */
public class XMLParserMalformedTemplateException extends XMLParserException {

	private static final long serialVersionUID = -585162805465628948L;

	/**
	 * Constructs a new malformed template exception for with the given message.
	 *
	 * @param message
	 *            the message describing the exception.
	 */
	public XMLParserMalformedTemplateException(String message) {
		super(message);
	}

	/**
	 * Constructs a new malformed template exception for with the given message and cause.
	 *
	 * @param message
	 *            the message describing the exception.
	 * @param cause
	 *            the cause of this exception.
	 */
	public XMLParserMalformedTemplateException(String message, Throwable cause) {
		super(message, cause);
	}

}
