/**
 * Java
 *
 * Copyright 2011 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.java.nodes;

import com.is2t.java.JavaSourceGenerator;

public class CompilationUnit extends JavaSourceNode{

	public static final char[][] DefaultPackage = new char[0][];
	
	public char[][] packageName;
	public char[] name;				//  if this compilationUnit contains a public class, name = this class name
									// if only private class, generated name
	
	public TypeDeclaration[] types;
	

	public CompilationUnit(char[][] packageName, char[] name, TypeDeclaration[] types){
		this.packageName = packageName;
		this.name = name;
		this.types = types;
	}
	
	
	
	@Override
	public void generateUsing(JavaSourceGenerator gen) {
		gen.generateCompilationUnit(this);
	}
	
	/**
	 * @return the public class of the unit or null if no public class in this unit
	 * NOTE : a unit cannot declare 2 public classes
	 */
	public TypeDeclaration getPublicType() {
		for (int i = types.length; --i >=0;) {
			if ( types[i].modifiers.isPublic())
				return types[i];
		}
		return null;
	}
	
}
