package com.is2t.java.nodes.expressions;

import com.is2t.java.JavaSourceGenerator;
import com.is2t.java.nodes.Expression;
import com.is2t.java.nodes.FieldDeclaration;

public class FieldAccess extends Expression {

	// if this field points a generated field, declaration is set and name = declaration.name
	// for pre-existing fields, declaration is null and name is the name of the field access
	public FieldDeclaration declaration;
	public char[][] declarationFullyQualifiedName;	// may be null name of declaration (useful when declaration is not set)
	public char[] name;	
	
	/**
	 * May be null when field is static
	 */
	public Expression receiver;
	
	public FieldAccess(FieldDeclaration declaration, Expression receiver){
		this.declaration = declaration;
		this.receiver = receiver;
		this.name = declaration.name;
		if(!declaration.isArrayLength())
			this.declarationFullyQualifiedName = declaration.declarationType.fullyQualifiedName;
	}
	
	public FieldAccess(char[][]  declarationFullyQualifiedName, char[] fieldName, Expression receiver){
		// this.declaration = null; vm done
		this.receiver = receiver;
		this.name = fieldName;
		this.declarationFullyQualifiedName = declarationFullyQualifiedName;
	}
	
	public void generateExpressionUsing(JavaSourceGenerator gen) {
		gen.generateFieldAccess(this);
	}

	public boolean isArrayLength() {
		return declaration != null && declaration.isArrayLength();
	}

}
