/*
 * Java
 *
 * Copyright 2015-2020 MicroEJ Corp. All rights reserved.
 * This library is provided in source code for use, modification and test, subject to license terms.
 * Any modification of the source code will break MicroEJ Corp. warranties on the whole library.
 */
package ej.microui;

import java.security.Permission;

import ej.annotation.Nullable;

/**
 * microUI-API
 */
public class MicroUIPermission extends Permission {

	private static final long serialVersionUID = 1L;

	/**
	 * microUI-API
	 */
	public static final String ACTION_START = "start"; //$NON-NLS-1$

	/**
	 * microUI-API
	 */
	public static final String ACTION_STOP = "stop"; //$NON-NLS-1$

	private final String action;

	/**
	 * microUI-API
	 *
	 * @param action
	 *            microUI-API
	 */
	public MicroUIPermission(String action) {
		super(null);
		this.action = action;
	}

	@Override
	public boolean equals(@Nullable Object obj) {
		MicroUIPermission otherPerm;
		try {
			otherPerm = (MicroUIPermission) obj;
		} catch (ClassCastException e) {
			return false;
		}
		return otherPerm != null && this.action.equals(otherPerm.action);
	}

	@Override
	public String getActions() {
		return this.action;
	}

	@Override
	public int hashCode() {
		return this.action.hashCode();
	}

	@Override
	public boolean implies(Permission permission) {
		return equals(permission);
	}

}
